<script setup>
import { computed, ref } from 'vue'
import { useUserStore } from '@/store/UserStore'
import { useRouter } from 'vue-router'
import { useField, useForm } from 'vee-validate'

const showPassword = ref(false)

const userStore = useUserStore()
const router = useRouter()

const { handleSubmit } = useForm({
  validationSchema: {
    password(value) {
      if (value?.length >= 2) return true

      return 'Name needs to be at least 2 characters.'
    },
    email(value) {
      if (/^[a-z.-]+@[a-z.-]+\.[a-z]+$/i.test(value)) return true

      return 'Must be a valid e-mail.'
    }
  }
})
const email = useField('email')
const password = useField('password')

const login = handleSubmit((values) => {
  userStore
    .loginUser(values)
    .then(() => {
      console.log(!error.value)
      if (!error.value) {
        router.push({
          name: 'ProtectedPage'
        })
      }
    })
    .catch((error) => {
      router.push({
        name: 'ErrorDisplay',
        params: { error: error }
      })
    })
})

const error = computed(() => {
  return userStore.error
})
</script>

<template>
  <form @submit.prevent="login">
    <v-card width="600" class="mx-auto mt-5">
      <v-card-title> Login </v-card-title>
      <v-card-text>
        <v-alert
          v-if="error"
          variant="outlined"
          border="top"
          type="error"
          title="Login error"
          :text="error"
          class="mb-5"
        ></v-alert>
        <v-text-field
          v-model="email.value.value"
          :error-messages="email.errorMessage.value"
          label="Email"
          prepend-icon="mdi-account-circle"
          required
        />
        <v-text-field
          v-model="password.value.value"
          :error-messages="password.errorMessage.value"
          :type="showPassword ? 'text' : 'password'"
          label="Password"
          prepend-icon="mdi-lock"
          :append-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"
          @click:append="showPassword = !showPassword"
          required
        />
      </v-card-text>
      <v-divider></v-divider>
      <v-card-actions>
        <v-btn color="success" :to="{ path: '/register' }">Don't have an account? Register.</v-btn>
        <v-spacer></v-spacer>
        <v-btn color="info" type="submit">Login</v-btn>
      </v-card-actions>
    </v-card>
  </form>
</template>

<style scoped></style>
